#include "omil.h"

#include "gs.h"
#include "t3_d3dbase.h"
#include "tank31fct.h"
#include "t3math.h"
#include "terra.h"
#include "matrixmath.h"

tmildsc mildsc[OMILTYPES];

mil omil[OMILS];


void calcomil(){
  for(int i=0;i<OMILS;i++){
    if(omil[i].used&&!omil[i].thisisstatic){
      // fahren
      omil[i].x-=tsin(omil[i].a)*omil[i].sp*speedgs.c;
      omil[i].y+=tcos(omil[i].a)*omil[i].sp*speedgs.c;
      // drehen
      omil[i].a+=omil[i].da*speedgs.c;
      // z-position
      omil[i].z=height(omil[i].x, omil[i].y)-0.35f;
      // b, c
      omil[i].b=(float)atan((height(omil[i].x+0.88f*tsin(omil[i].a), omil[i].y-0.88f*tcos(omil[i].a))-height(omil[i].x-0.88f*tsin(omil[i].a), omil[i].y+0.88f*tcos(omil[i].a)))*0.568f);
      omil[i].c=(float)atan((height(omil[i].x-0.66f*tcos(omil[i].a), omil[i].y-0.66f*tsin(omil[i].a))-height(omil[i].x+0.66f*tcos(omil[i].a), omil[i].y+0.66f*tsin(omil[i].a)))*0.757f);
      // a, ta auf 2*PI begrenzen
      omil[i].a=begrf(omil[i].a, 2*PI);
      if(omil[i].a>PI)omil[i].a-=2*PI;
      omil[i].ta=begrf(omil[i].ta, 2*PI);
      if(omil[i].ta>PI)omil[i].ta-=2*PI;
      // turret displacement
      omil[i].tdp-=0.6f*speedgs.c;
      if(omil[i].tdp<0)omil[i].tdp=0;
    }
  }
}

void attack(int n, int tgt){
  int i;
  omil[n].target=tgt;
  omil[n].ttarget=tgt;
  omil[n].hitting=true;
  int num=0;
  for(i=0;i<OMILS;i++){
    if(i!=n&&omil[i].used&&omil[i].owner==omil[n].owner&&omil[i].target==-1&&omil[i].ttarget==-1){
      float dstsq=((omil[n].x-omil[i].x)*(omil[n].x-omil[i].x)
                    +(omil[n].y-omil[i].y)*(omil[n].y-omil[i].y));
      if(dstsq<GROUPATTACKDST*GROUPATTACKDST){
        omil[i].target=tgt;
        omil[i].ttarget=tgt;
        omil[i].hitting=true;
        num++;
      }
    }
    if(num>=GROUPATTACKNUM)break;
  }
}

void ki(int n){
  int i;
  // target
  if(omil[n].owner!=0&&omil[n].target==-1){
    for(i=0;i<OMILS;i++){
      if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner&&omil[i].owner!=3){
        float dstsq=((omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)+(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y));
        if(dstsq<mildsc[omil[n].typ].range*mildsc[omil[n].typ].range){
          attack(n, i);
          break;
        }
      }
    }
  }
  // ttarget
  if(omil[n].ttarget==-1){
    for(i=0;i<OMILS;i++){
      if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner&&omil[i].owner!=3){
        float dstsq=((omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)+(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y));
        if(dstsq<mildsc[omil[n].typ].range*mildsc[omil[n].typ].range){
//          omil[n].hitting=true;
          omil[n].ttarget=i;
          break;
        }
      }
    }
  }
  // MARS target
  if(omil[n].typ==2&&omil[n].target>=0&&!omil[n].mtarget){
    float dstsq=((omil[omil[n].target].x-omil[n].x)*(omil[omil[n].target].x-omil[n].x)+(omil[omil[n].target].y-omil[n].y)*(omil[omil[n].target].y-omil[n].y));
    if(dstsq<mildsc[omil[n].typ].range*MARSRANGE*mildsc[omil[n].typ].range*MARSRANGE){
      for(i=0;i<OMILS;i++){
        if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner&&omil[i].owner!=3){
          float dstsq=((omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)+(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y));
          if(dstsq<mildsc[omil[n].typ].range*mildsc[omil[n].typ].range
          &&dstsq>mildsc[omil[n].typ].range*MARSRANGE*mildsc[omil[n].typ].range*MARSRANGE){
            attack(n, i);
            break;
          }
        }
      }
    }
  }
  // MARS ttarget
  if(omil[n].typ==2&&omil[n].ttarget>=0&&!omil[n].mtarget){
    float dstsq=((omil[omil[n].ttarget].x-omil[n].x)*(omil[omil[n].ttarget].x-omil[n].x)+(omil[omil[n].ttarget].y-omil[n].y)*(omil[omil[n].ttarget].y-omil[n].y));
    if(dstsq<mildsc[omil[n].typ].range*MARSRANGE*mildsc[omil[n].typ].range*MARSRANGE){
      for(i=0;i<OMILS;i++){
        if(omil[i].used&&i!=n&&omil[i].owner!=omil[n].owner&&omil[i].owner!=3){
          float dstsq=((omil[i].x-omil[n].x)*(omil[i].x-omil[n].x)+(omil[i].y-omil[n].y)*(omil[i].y-omil[n].y));
          if(dstsq<mildsc[omil[n].typ].range*mildsc[omil[n].typ].range
          &&dstsq>mildsc[omil[n].typ].range*MARSRANGE*mildsc[omil[n].typ].range*MARSRANGE){
            omil[n].ttarget=i;
            break;
          }
        }
      }
    }
  }
  // Tank
  // waiting
  if(omil[n].target==-1){
    omil[n].sp=0;
    omil[n].da=0;
    omil[n].tb*=0.8f;
  }
  float atot, tatot, aot, taot;
  // waypoint
  if(omil[n].target==-2){
    // Richtung des Ziels
    if(omil[n].targety-omil[n].y!=0){
      atot=(float)atan((omil[n].x-omil[n].targetx)/(omil[n].targety-omil[n].y));
    }else{
      atot=(float)atan((omil[n].x-omil[n].targetx)*(1E20));
    }
    if(omil[n].targety<omil[n].y)atot=atot+PI;
    float posd=100, negd=100, aot;
    if(atot-omil[n].a>0&&atot-omil[n].a<posd)posd=atot-omil[n].a;
    if(omil[n].a-atot>0&&omil[n].a-atot<negd)negd=omil[n].a-atot;
    if(atot-omil[n].a+2*PI>0&&atot-omil[n].a+2*PI<posd)posd=atot-omil[n].a+2*PI;
    if(omil[n].a-atot+2*PI>0&&omil[n].a-atot+2*PI<negd)negd=omil[n].a-atot+2*PI;
    if(atot-omil[n].a-2*PI>0&&atot-omil[n].a-2*PI<posd)posd=atot-omil[n].a-2*PI;
    if(omil[n].a-atot-2*PI>0&&omil[n].a-atot-2*PI<negd)negd=omil[n].a-atot-2*PI;
    omil[n].da=0;
    if(posd<negd){
      omil[n].da=minf(0.6f*TURNSPEED, posd*3);
      aot=posd;
    }else{
      omil[n].da=-minf(0.6f*TURNSPEED, negd*3);
      aot=-negd;
    }
    float dstsq=((omil[n].targety-omil[n].y)*(omil[n].targety-omil[n].y)
                +(omil[n].targetx-omil[n].x)*(omil[n].targetx-omil[n].x));
    omil[n].sp=0;
    if(dstsq>0.5f&&absf(aot)<PI/4){
      omil[n].sp=mildsc[omil[n].typ].maxspeed;
    } else {
      omil[n].sp=0;
    }
    if(dstsq<=0.5f){
      omil[n].target=-1;
    }
  }
  // attack
  if(omil[n].target>=0){
    if(omil[omil[n].target].y-omil[n].y!=0){
      atot=(float)atan((omil[n].x-omil[omil[n].target].x)/(omil[omil[n].target].y-omil[n].y));
    }else{
      atot=(float)atan((omil[n].x-omil[omil[n].target].x)*(1E20));
    }
    if(omil[omil[n].target].y<omil[n].y)atot=atot+PI;
    float posd=100, negd=100;
    if(atot-omil[n].a>0&&atot-omil[n].a<posd)posd=atot-omil[n].a;
    if(omil[n].a-atot>0&&omil[n].a-atot<negd)negd=omil[n].a-atot;
    if(atot-omil[n].a+2*PI>0&&atot-omil[n].a+2*PI<posd)posd=atot-omil[n].a+2*PI;
    if(omil[n].a-atot+2*PI>0&&omil[n].a-atot+2*PI<negd)negd=omil[n].a-atot+2*PI;
    if(atot-omil[n].a-2*PI>0&&atot-omil[n].a-2*PI<posd)posd=atot-omil[n].a-2*PI;
    if(omil[n].a-atot-2*PI>0&&omil[n].a-atot-2*PI<negd)negd=omil[n].a-atot-2*PI;
    omil[n].da=0;
    if(posd<negd){
      omil[n].da=minf(0.6f*TURNSPEED, posd*3);
      aot=posd;
    }else{
      omil[n].da=-minf(0.6f*TURNSPEED, negd*3);
      aot=-negd;
    }
    float dstsq=((omil[omil[n].target].y-omil[n].y)*(omil[omil[n].target].y-omil[n].y)
                +(omil[omil[n].target].x-omil[n].x)*(omil[omil[n].target].x-omil[n].x));
    omil[n].sp=0;
    if(((!omil[n].hitting)&&omil[n].typ!=2)||dstsq>mildsc[omil[n].typ].range*mildsc[omil[n].typ].range){
/*      if(omil[n].hitting){
        omil[n].sp=minf(1.0*TANKSPEED, dst-5);
      } else {*/
//        omil[n].sp=minf(mildsc[omil[n].typ].maxspeed, dstsq);
        omil[n].sp=mildsc[omil[n].typ].maxspeed;
//      }
    }
    if(dstsq>60*60&&!omil[n].mtarget&&omil[n].owner!=0)omil[n].target=-1;
    // tanks with mtarget select their target as ttarget if in range
    if(dstsq<mildsc[omil[n].typ].range*mildsc[omil[n].typ].range)omil[n].ttarget=omil[n].target;
  }
  // turret
  if(omil[n].ttarget>=0&&mildsc[omil[n].typ].shotspeed!=0){
    // target position
    float tgtx, tgty, tgtz, nx, ny, nz;
    tgtx=omil[omil[n].ttarget].x-omil[n].x;
    tgty=omil[omil[n].ttarget].y-omil[n].y;
    tgtz=omil[omil[n].ttarget].z-omil[n].z;
    // Distance of turret target
    float dstsq=(tgtx*tgtx+tgty*tgty+tgtz*tgtz);
    float dst=(float)sqrt(dstsq);
    // virtual position 1 (eliminate speed, gravity) for turret target
    // eliminate speed
    tgtx+=omil[omil[n].ttarget].sp*-tsin(omil[omil[n].ttarget].a)*(dst/mildsc[omil[n].typ].shotspeed); // s=v*t
    tgty+=omil[omil[n].ttarget].sp*tcos(omil[omil[n].ttarget].a)*(dst/mildsc[omil[n].typ].shotspeed);  // [m]=[m/s]*[s]
    // eliminate height difference
    tgtz-=height(omil[omil[n].ttarget].x, omil[omil[n].ttarget].y);
    tgtz+=height(tgtx, tgty);
    // Distance has changed...
    dstsq=(tgtx*tgtx+tgty*tgty+tgtz*tgtz);
    dst=(float)sqrt(dstsq);
    // eliminate gravity
    tgtz-=0.5f*SHOTGRAVITY*dstsq/(mildsc[omil[n].typ].shotspeed*mildsc[omil[n].typ].shotspeed); // s=1/2*a*t^2
//    tgtz-=0.9*0.5*SHOTGRAVITY*(dst/mildsc[omil[n].typ].shotspeed)*(dst/mildsc[omil[n].typ].shotspeed); // s=1/2*a*t^2
    // Distance has changed...
    dstsq=(tgtx*tgtx+tgty*tgty+tgtz*tgtz);
    dst=(float)sqrt(dstsq);
    // virtual position 2 (terrain tangent angles of omil[n]) for turret target
    nx=tgtx*tcos(-omil[n].a)-tgty*tsin(-omil[n].a);
    ny=tgty*tcos(-omil[n].a)+tgtx*tsin(-omil[n].a);
    tgtx=nx;
    tgty=ny;
    nx=tgtz*tsin(-omil[n].c)+tgtx*tcos(-omil[n].c);
    nz=tgtz*tcos(-omil[n].c)-tgtx*tsin(-omil[n].c);
    tgtx=nx;
    tgtz=nz;
    ny=tgtz*tsin(-omil[n].b)+tgty*tcos(-omil[n].b);
    nz=tgtz*tcos(-omil[n].b)-tgty*tsin(-omil[n].b);
    tgty=ny;
    tgtz=nz;
    tgtx+=omil[n].x;
    tgty+=omil[n].y;
    tgtz+=omil[n].z;
    // end of virtual position calculation
    // angle of target (Tank)
/*    if(omil[omil[n].target].y-omil[n].y!=0){
      atot=atan((omil[n].x-omil[omil[n].ttarget].x)/(omil[omil[n].ttarget].y-omil[n].y));
    }else{
      atot=atan((omil[n].x-omil[omil[n].ttarget].x)/(1E-20));
    }
    if(omil[omil[n].target].y<omil[n].y)atot=atot+PI;*/
    // angle of target (turret)
    if(tgty-omil[n].y!=0){
      tatot=(float)atan((omil[n].x-tgtx)/(tgty-omil[n].y));
    }else{
      tatot=(float)atan((omil[n].x-tgtx)/(1E-20));
    }
    if(tgty<omil[n].y)tatot=tatot+PI;
    // Turm b-Richtung
    if(dst!=0)omil[n].tb=(float)atan((omil[n].z-tgtz)/dst);
//    if(tgtz<omil[n].z)omil[n].tb+=PI;
    // begrenzen
    if(omil[n].tb>PI/4)omil[n].tb=PI/4;
    if(omil[n].tb<-0.17f)omil[n].tb=-0.17f;
    // Turm a-Richtung
    float posd=100, negd=100;
    if(tatot-(omil[n].ta)>=0&&tatot-(omil[n].ta)<posd)posd=tatot-(omil[n].ta);
    if((omil[n].ta)-tatot>0&&(omil[n].ta)-tatot<negd)negd=(omil[n].ta)-tatot;
    if(tatot-(omil[n].ta)+2*PI>=0&&tatot-(omil[n].ta)+2*PI<posd)posd=tatot-(omil[n].ta)+2*PI;
    if((omil[n].ta)-tatot+2*PI>0&&(omil[n].ta)-tatot+2*PI<negd)negd=(omil[n].ta)-tatot+2*PI;
    if(tatot-(omil[n].ta)-2*PI>=0&&tatot-(omil[n].ta)-2*PI<posd)posd=tatot-(omil[n].ta)-2*PI;
    if((omil[n].ta)-tatot-2*PI>0&&(omil[n].ta)-tatot-2*PI<negd)negd=(omil[n].ta)-tatot-2*PI;
    if(tatot-(omil[n].ta)+4*PI>=0&&tatot-(omil[n].ta)+4*PI<posd)posd=tatot-(omil[n].ta)+4*PI;
    if((omil[n].ta)-tatot+4*PI>0&&(omil[n].ta)-tatot+4*PI<negd)negd=(omil[n].ta)-tatot+4*PI;
    if(tatot-(omil[n].ta)-4*PI>=0&&tatot-(omil[n].ta)-4*PI<posd)posd=tatot-(omil[n].ta)-4*PI;
    if((omil[n].ta)-tatot-4*PI>0&&(omil[n].ta)-tatot-4*PI<negd)negd=(omil[n].ta)-tatot-4*PI;
    if(posd<negd){
//      omil[i].ta+=posd;
      omil[n].ta+=minf(TURRETTURNSPEED*speedgs.c, posd);
      taot=posd;
    }else{
//      omil[i].ta-=negd;
      omil[n].ta-=minf(TURRETTURNSPEED*speedgs.c, negd);
      taot=-negd;
    }
/*    float posd=100, negd=100;
    if(omil[n].atot-omil[n].a>0&&omil[n].atot-omil[n].a<posd)posd=omil[n].atot-omil[n].a;
    if(omil[n].a-omil[n].atot>0&&omil[n].a-omil[n].atot<negd)negd=omil[n].a-omil[n].atot;
    if(omil[n].atot-omil[n].a+2*PI>0&&omil[n].atot-omil[n].a+2*PI<posd)posd=omil[n].atot-omil[n].a+2*PI;
    if(omil[n].a-omil[n].atot+2*PI>0&&omil[n].a-omil[n].atot+2*PI<negd)negd=omil[n].a-omil[n].atot+2*PI;
    if(omil[n].atot-omil[n].a-2*PI>0&&omil[n].atot-omil[n].a-2*PI<posd)posd=omil[n].atot-omil[n].a-2*PI;
    if(omil[n].a-omil[n].atot-2*PI>0&&omil[n].a-omil[n].atot-2*PI<negd)negd=omil[n].a-omil[n].atot-2*PI;
    omil[n].da=0;
    if(posd<negd){
      omil[n].da=minf(0.6*TURNSPEED, posd*3);
      aott=posd;
    }else{
      omil[n].da=-minf(0.6*TURNSPEED, negd*3);
      aott=-negd;
    }*/
    if(taot<PI/32&&mildsc[omil[n].typ].canshoot)shoot(n);
    if(dstsq>60*60&&!omil[n].mtarget)omil[n].ttarget=-1;
  }
  if(omil[n].ttarget==-1){
    omil[n].ta+=maxf(minf(TURRETTURNSPEED*speedgs.c, -omil[n].ta), -TURRETTURNSPEED*speedgs.c);
  }
}

void mildscinit(void){
  mildsc[0].maxspeed=TANKSPEED; // tank
  mildsc[0].shotspeed=SHOTSPEED;
  mildsc[0].size=1.0;
  mildsc[0].range=20;
  mildsc[0].shothit=7;
  mildsc[0].hitpoints=200;
  mildsc[0].shotfreq=1;
  mildsc[0].canshoot=true;
  mildsc[1].maxspeed=1.1f*TANKSPEED; // stank
  mildsc[1].shotspeed=0.8f*SHOTSPEED;
  mildsc[1].size=0.9f;
  mildsc[1].range=15;
  mildsc[1].shothit=3;
  mildsc[1].hitpoints=120;
  mildsc[1].shotfreq=0.6f;
  mildsc[1].canshoot=true;
  mildsc[2].maxspeed=0.6f*TANKSPEED; // MARS
  mildsc[2].shotspeed=1.5f*SHOTSPEED;
  mildsc[2].size=1.5f;
  mildsc[2].range=30;
  mildsc[2].shothit=3;
  mildsc[2].hitpoints=120;
  mildsc[2].shotfreq=1.5f;
  mildsc[2].canshoot=true;
  mildsc[3].maxspeed=1.4f*TANKSPEED; // hummvee
  mildsc[3].shotspeed=1.6f*SHOTSPEED;
  mildsc[3].size=0.7f;
  mildsc[3].range=20;
  mildsc[3].shothit=0.8f;
  mildsc[3].hitpoints=80;
  mildsc[3].shotfreq=0.20f;
  mildsc[3].canshoot=true;
  mildsc[4].maxspeed=1.2f*TANKSPEED; // pritsche
  mildsc[4].shotspeed=1.6f*SHOTSPEED;
  mildsc[4].size=0.7f;
  mildsc[4].range=20;
  mildsc[4].shothit=1;
  mildsc[4].hitpoints=80;
  mildsc[4].shotfreq=3;
  mildsc[4].canshoot=false;
  mildsc[5].maxspeed=1.1f*TANKSPEED; // tonner
  mildsc[5].shotspeed=1.6f*SHOTSPEED;
  mildsc[5].size=0.7f;
  mildsc[5].range=20;
  mildsc[5].shothit=1;
  mildsc[5].hitpoints=100;
  mildsc[5].shotfreq=3;
  mildsc[5].canshoot=false;
  mildsc[6].maxspeed=1*TANKSPEED; // bus
  mildsc[6].shotspeed=1.6f*SHOTSPEED;
  mildsc[6].size=0.7f;
  mildsc[6].range=20;
  mildsc[6].shothit=1;
  mildsc[6].hitpoints=80;
  mildsc[6].shotfreq=3;
  mildsc[6].canshoot=false;
  mildsc[7].maxspeed=1.4f*TANKSPEED; // wolf
  mildsc[7].shotspeed=1.6f*SHOTSPEED;
  mildsc[7].size=0.7f;
  mildsc[7].range=20;
  mildsc[7].shothit=1;
  mildsc[7].hitpoints=100;
  mildsc[7].shotfreq=3;
  mildsc[7].canshoot=false;
  mildsc[8].maxspeed=0; // house (stone)
  mildsc[8].shotspeed=400*SHOTSPEED;
  mildsc[8].size=2;
  mildsc[8].range=0;
  mildsc[8].shothit=1;
  mildsc[8].hitpoints=200;
  mildsc[8].shotfreq=300;
  mildsc[8].canshoot=false;
  mildsc[9].maxspeed=0; // house (wood)
  mildsc[9].shotspeed=300*SHOTSPEED;
  mildsc[9].size=2;
  mildsc[9].range=0;
  mildsc[9].shothit=1;
  mildsc[9].hitpoints=200;
  mildsc[9].shotfreq=300;
  mildsc[9].canshoot=false;
  mildsc[10].maxspeed=0; // golf (red)
  mildsc[10].shotspeed=300*SHOTSPEED;
  mildsc[10].size=0.7f;
  mildsc[10].range=0;
  mildsc[10].shothit=1;
  mildsc[10].hitpoints=200;
  mildsc[10].shotfreq=300;
  mildsc[10].canshoot=false;
  mildsc[11].maxspeed=0; // golf (jazz blue pearl effect)
  mildsc[11].shotspeed=300*SHOTSPEED;
  mildsc[11].size=0.7f;
  mildsc[11].range=0;
  mildsc[11].shothit=1;
  mildsc[11].hitpoints=200;
  mildsc[11].shotfreq=300;
  mildsc[11].canshoot=false;
}

void shoot(int n){
  if(speedgs.g>omil[n].lastshot+mildsc[omil[n].typ].shotfreq){
    for(int i=0;i<NUMSHOTS;i++){
      if(!shot[i].used){
        shot[i].used=true;
        omil[n].tdp=0.1f;
        shot[i].x=omil[n].x+0.999f*omil[n].tdx;
        shot[i].y=omil[n].y+0.999f*omil[n].tdy;
        shot[i].z=omil[n].z-0.111f+0.999f*omil[n].tdz;
        shot[i].lastsmoke=speedgs.g;
        if(omil[n].typ!=3||begr(rand(),7)==0)newparticle(3, shot[i].x, shot[i].y, shot[i].z, 1, false);
        shot[i].split=-1;
        if(omil[n].typ==2){
          float dst=(float)sqrt((omil[n].x-omil[omil[n].ttarget].x)*(omil[n].x-omil[omil[n].ttarget].x)
                               +(omil[n].y-omil[omil[n].ttarget].y)*(omil[n].y-omil[omil[n].ttarget].y));
          if(dst>mildsc[omil[n].typ].range*MARSRANGE){
            shot[i].split=speedgs.g+0.5f*dst/mildsc[omil[n].typ].shotspeed;// 0.5*T
          }
        }
        float nx, ny, nz;
        // calculate heading of turret
        omil[n].tdx=0;
        omil[n].tdy=1;
        omil[n].tdz=0;
        ny=omil[n].tdy*tcos(omil[n].tb)+omil[n].tdz*tsin(omil[n].tb);
        nz=omil[n].tdz*tcos(omil[n].tb)-omil[n].tdy*tsin(omil[n].tb);
        omil[n].tdy=ny;
        omil[n].tdz=nz;
        nx=omil[n].tdx*tcos(omil[n].ta)-omil[n].tdy*tsin(omil[n].ta);
        ny=omil[n].tdy*tcos(omil[n].ta)+omil[n].tdx*tsin(omil[n].ta);
        omil[n].tdx=nx;
        omil[n].tdy=ny;
        ny=omil[n].tdy*tcos(omil[n].b)+omil[n].tdz*tsin(omil[n].b);
        nz=omil[n].tdz*tcos(omil[n].b)-omil[n].tdy*tsin(omil[n].b);
        omil[n].tdy=ny;
        omil[n].tdz=nz;
        nx=omil[n].tdx*tcos(omil[n].c)+omil[n].tdz*tsin(omil[n].c);
        nz=omil[n].tdz*tcos(omil[n].c)-omil[n].tdx*tsin(omil[n].c);
        omil[n].tdx=nx;
        omil[n].tdz=nz;
        nx=omil[n].tdx*tcos(omil[n].a)-omil[n].tdy*tsin(omil[n].a);
        ny=omil[n].tdy*tcos(omil[n].a)+omil[n].tdx*tsin(omil[n].a);
        omil[n].tdx=nx;
        omil[n].tdy=ny;
        float fac=(float)sqrt(omil[n].tdx*omil[n].tdx+omil[n].tdy*omil[n].tdy);
        shot[i].dx=omil[n].tdx*mildsc[omil[n].typ].shotspeed/fac;
        shot[i].dy=omil[n].tdy*mildsc[omil[n].typ].shotspeed/fac;
        shot[i].dz=omil[n].tdz*mildsc[omil[n].typ].shotspeed/fac;
        // sqrt(omil[n].tdx*omil[n].tdx+omil[n].tdy*omil[n].tdy) must be 1 for later calculations
        shot[i].t=speedgs.g;
        shot[i].typ=omil[n].typ;
        shot[i].owner=omil[n].owner;
        shot[i].tank=n;
#ifndef DISABLESHOTLIGHTING
        // lighting
//        gs->d3d->CreateLight(&shot[i].light, NULL);
        dxlight=shotlight(i);
//        shot[i].light->SetLight(&dxlight);
        gs->d3d->d3ddevice->SetLight(SHOTLIGHTOFFSET+i, &dxlight);
        gs->d3d->d3ddevice->LightEnable(SHOTLIGHTOFFSET+i, TRUE);
//        gs->d3dviewport->AddLight(shot[i].light);
#endif
        if(omil[n].typ==2){
          play(3);
        } else {
          if(omil[n].typ>=3){
            play(2);
          } else {
           play(0);
          }
        }
        break;
      }
    }
    omil[n].lastshot=speedgs.g;
  }
}

void rendermil(mil* milobj){
//  startprofile(12);
  D3DVECTOR mv=makevector(milobj->x, milobj->y, milobj->z);
//  D3DMATRIX mtx=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, milobj->x, milobj->y, milobj->z, 1);
//  mapply(&mv, mtx);
  mapply2d(&mv);
/*  mapply(&mv, mtx);
  mapply(&mv, viewmtx);
  mapply(&mv, projmtx);*/
  milobj->sx=mv.x;
  milobj->sy=mv.y;
//  stopprofile(12);
  int ftopend=TOPEND;
  if(view.firstperson)ftopend+=FIRSTTOPPLUS;
  if(milobj->sx > -1.25f && milobj->sx < 1.25f && milobj->sy > -1.25f && milobj->sy < 1.25f){
//    startprofile(13);
    int objnum=(milobj->owner==1?2:0)+milobj->typ*4;
    renderobj(&obj[objnum], milobj->x, milobj->y, milobj->z, milobj->a, milobj->b, milobj->c, milobj->dead);
//    stopprofile(13);
//    startprofile(14);
    rendersecobj(&obj[1+objnum], milobj->x, milobj->y, milobj->z,milobj->ta,milobj->tb,0, milobj->a, milobj->b, milobj->c, milobj->tdp, milobj->dead);
//    stopprofile(14);
  }
/*      gs->d3d->d3ddevice->SetRenderState(D3DRS_ZFUNC,D3DCMP_ALWAYS);
      gs->d3d->d3ddevice->SetRenderState(D3DRS_ZWRITEENABLE,FALSE);
      D3DMATRIX matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
      gs->d3d->d3ddevice->SetTransform(D3DTS_VIEW, &matrix);
      matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
      gs->d3d->d3ddevice->SetTransform(D3DTS_PROJECTION, &matrix);
//      mv.x=mv.y=mv.z=1;
      matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, mv.x, mv.y, mv.z, 1);
//      matrix=makematrix(1,0,0,0, 0,1,0,0, 0,0,1,0, 0, 0, 0, 1);
      gs->d3d->d3ddevice->SetTransform(D3DTS_WORLD, &matrix);
      D3DBVERTEX vx[4];
      gs->d3d->d3ddevice->SetTexture(0, dxstexture[0]);
      vx[0]=makevertex(makevector(-0.1, -0.1, 0), makevector(0,0,-1), 0, 0);
      vx[1]=makevertex(makevector(-0.1, 0.1, 0), makevector(0,0,-1), 0, 1);
      vx[2]=makevertex(makevector(0.1, -0.1, 0), makevector(0,0,-1), 1, 0);
      vx[3]=makevertex(makevector(0.1, 0.1, 0), makevector(0,0,-1), 1, 1);
      gs->d3d->d3ddevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DBFVF_VERTEX,&vx[0],4,0);
      gs->d3d->d3ddevice->SetTransform(D3DTS_VIEW, &viewmtx);
      gs->d3d->d3ddevice->SetTransform(D3DTS_PROJECTION, &projmtx);
      gs->d3d->d3ddevice->SetRenderState(D3DRS_ZWRITEENABLE,TRUE);
      gs->d3d->d3ddevice->SetRenderState(D3DRS_ZFUNC,STDCOMPFUNC);*/
}
