#include "tank31.h"

#include "gs.h"

// gamestruct
cgs *gs;

int WINAPI WinMain(HINSTANCE ThisInstance, HINSTANCE PrevInstance, LPSTR Argument, int WindowStyle)
{
	// start in fullscreen mode
	WindowStyle = SW_SHOWMAXIMIZED;
	// call gamestruct constructor
	gs = new cgs(ThisInstance, WindowStyle);
	// variables for message handling
	bool quitgame = false;
	MSG msg;
	// main message handling loop
	while ( !quitgame )
	{
		if ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			if ( msg.message == WM_QUIT )
			{
				quitgame=TRUE;
			}
			else
			{
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
		}
		else
		{
			// gamestruct main loop function
			gs->mainloop();
		}
	}
	// call the destructor of gs, clean up
	delete gs;
	return 0;
}
