#include <d3dx8.h>

class XMESH
	{
	private:
		DWORD				dwNumMaterials;  // Anzahl der im Modell verwendeten Materials
		D3DMATERIAL8*		pMeshMaterial;   // Die Materials
		LPDIRECT3DTEXTURE8* pMeshTexture;    // Die jeweils zum Material gehrende Textur
		LPD3DXMESH			pMesh;           // Das Modell
	public:
		XMESH();
		BOOL Load_XFile(char* FileName, LPDIRECT3DDEVICE8 lpD3DDevice); //Modell laden
		BOOL Draw_XFile(LPDIRECT3DDEVICE8 lpD3DDevice);                 //Modell zeichnen
		~XMESH();
	};