#include "gs.h"
#include "tank31fct.h"

#include "constants.h"
#include "terra.h"
#include "t3math.h"
#include "tank31fct.h"
#include "overlay.h"
#include "mission.h"

void mouseinput(void){
  int i;
  if(!view.menu){
   // scroll
   if(mouse.x<10){view.px-=15*speedgs.c*view.zoom;mouse.downx+=speedgs.c*1.5f;view.changed = true;}
   if(mouse.y<10){view.py+=15*speedgs.c*view.zoom;mouse.downy-=speedgs.c*1;view.changed = true;}
   if(mouse.x>gs->d3d->xres-10){view.px+=15*speedgs.c*view.zoom;mouse.downx-=speedgs.c*1.5f;view.changed = true;}
   if(mouse.y>gs->d3d->yres-10){view.py-=15*speedgs.c*view.zoom;mouse.downy+=speedgs.c*1;view.changed = true;}
   if(view.px<-LEFTEND+15)view.px=-LEFTEND+15;
   if(view.px>FIELDX*TERRAFAC-RIGHTEND)view.px=FIELDX*TERRAFAC-RIGHTEND;
   if(view.py<-BOTTOMEND+5)view.py=-BOTTOMEND+5;
   if(view.py>FIELDY*TERRAFAC-TOPEND)view.py=FIELDY*TERRAFAC-TOPEND;
   if(mouse.rdown){
    for(i=0;i<OMILS;i++){
      omil[i].selected=false;
    }
    mouse.rdown=false;
   }
   if(mouse.up){
    float x=((2.0f*mouse.x)/gs->d3d->xres-1.0f),y=(1.0f-(2.0f*mouse.y)/gs->d3d->yres);
    if(absf(x-mouse.downx)<0.017f&&absf(y-mouse.downy)<0.017f){
      // Klick
      bool sel=false;
      bool selopp=false;
      int opp=-1;
      for(i=0;i<OMILS;i++){
        if(omil[i].used){
          if(absf(omil[i].sx-(2.0f*mouse.x/gs->d3d->xres-1))<0.1f&&absf(omil[i].sy-(1-2.0f*mouse.y/gs->d3d->yres))<0.1f){
            sel=true;
            if(omil[i].owner!=0){
              selopp=true;
              opp=i;
            }
          }
        }
      }
      if(sel){
        // tank
        if(!selopp){
          for(i=0;i<OMILS;i++){
            if(omil[i].used){
              if(absf(omil[i].sx-(2.0f*mouse.x/gs->d3d->xres-1))<0.1f&&absf(omil[i].sy-(1-2.0f*mouse.y/gs->d3d->yres))<0.1f){
                omil[i].selected=true;
              } else {
                omil[i].selected=false;
              }
            }
          }
        } else {
          sel=false;
          for(i=0;i<OMILS;i++){
            if(omil[i].used){
              if(omil[i].selected&&omil[i].owner==0&&!omil[i].noorders){
                omil[i].target=opp;
//                omil[i].ttarget=opp;
                sel=true;
              }
            }
          }
          if(!sel){
            for(i=0;i<OMILS;i++){
              if(i==opp){
                omil[i].selected=true;
              } else {
                omil[i].selected=false;
              }
            }
          }
        }
      } else {
        // waypoint
        int num=0;
        float mx=0, my=0;
        for(i=0;i<OMILS;i++){
          if(omil[i].used){
            if(omil[i].selected&&omil[i].owner==0&&!omil[i].noorders){
              num++;
              mx+=omil[i].x;
              my+=omil[i].y;
            }
          }
        }
        if(num!=0){
          mx/=num;
          my/=num;
        }
        for(i=0;i<OMILS;i++){
          if(omil[i].used){
            if(omil[i].selected&&omil[i].owner==0&&!omil[i].noorders){
              omil[i].target=-2;
              omil[i].targetx=view.px+view.zoom*(2.0f*mouse.x/gs->d3d->xres-1)*1.5f*VIEWDIV*0.2f*(5+(1-2.0f*mouse.y/gs->d3d->yres));
              omil[i].targety=view.py+view.zoom*(1-2.0f*mouse.y/gs->d3d->yres)*1.95f*VIEWDIV-2;
              omil[i].targetx+=omil[i].x-mx;
              omil[i].targety+=omil[i].y-my;
            }
          }
        }
      }
    } else {
      // Rectangle
      bool inthere=false;
      for(i=0;i<OMILS;i++){
        if(omil[i].used){
          int dx=(int)((mouse.downx+1.0)/2.0f*gs->d3d->xres), dy=(int)((1.0-mouse.downy)/2.0f*gs->d3d->yres);
          int px=mouse.x;
          int py=mouse.y;
          if(dx>px){
            int sw=px;
            px=dx;
            dx=sw;
          }
          if(dy>py){
            int sw=mouse.y;
            py=dy;
            dy=sw;
          }
          int sx=(int)((omil[i].sx+1.0f)/2.0f*gs->d3d->xres), sy=(int)((1.0-omil[i].sy)/2.0f*gs->d3d->yres);
          if(sx<px&&sx>dx
           &&sy<py&&sy>dy
           &&omil[i].owner==0&&!omil[i].noorders){
            inthere=true;
          }
        }
      }
      if(inthere){
        for(i=0;i<OMILS;i++){
          if(omil[i].used){
            int dx=(int)((mouse.downx+1.0f)/2.0f*gs->d3d->xres), dy=(int)((1.0f-mouse.downy)/2.0f*gs->d3d->yres);
            int px=mouse.x;
            int py=mouse.y;
            if(dx>px){
              int sw=px;
              px=dx;
              dx=sw;
            }
            if(dy>py){
              int sw=mouse.y;
              py=dy;
              dy=sw;
            }
            int sx=(int)((omil[i].sx+1.0f)/2.0f*gs->d3d->xres), sy=(int)((1.0f-omil[i].sy)/2.0f*gs->d3d->yres);
            if(sx<px&&sx>dx
             &&sy<py&&sy>dy
             &&omil[i].owner==0&&!omil[i].noorders){
              omil[i].selected=true;
            } else {
              omil[i].selected=false;
            }
          }
        }
      }
    }
    mouse.down=false;
   }
   mouse.up=false;
  } else { // if view.menu
    if(mouse.up){
      float x=((2.0f*mouse.x)/gs->d3d->xres-1.0f),y=(1.0f-(2.0f*mouse.y)/gs->d3d->yres);
      float xt=(x+0.5f)*256,yt=(-y+0.5f)*256;
/*  if(n==1){
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 10, "Game Menu", 9);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 50, "Orders", 6);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 70, "Start New Game", 14);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 70, "Load Game", 9);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 70, "Save Game", 9);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 70, "Start Single Mission", 20);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 90, "Credits", 7);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 110, "Quit", 4);
  }
  if(n==6){
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 10, "Main Menu", 9);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 50, "Start New Game", 14);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 70, "Load Game", 9);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 90, "Start Single Mission", 20);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 110, "Credits", 7);
    T3TextOut4(true, &fontbig[0], TEXTSPACEOFF, 10, 130, "Quit", 4);
  }*/
/*
0:	Orders
1:	Game Menu
2:	Mission accomplished/failed
3:	Select Single mission
4:	Credits
5:	last mission accomplished
6:	Main Menu
7:	load game
8:	save game
*/
	  // view.menutype == 1
      if(view.menutype==1){
        if(yt>50&&yt<70&&xt>0&&xt<256){
          displaymenu(0);
          goto out;
        }
        if(yt>70&&yt<90&&xt>0&&xt<256){
		  strcpy(mission.fname, "missions\\1village.mis");
		  killgame();
		  gameinit();
          goto out;
        }
        if(yt>90&&yt<110&&xt>0&&xt<256){
          displaymenu(7);
          goto out;
        }
        if(yt>110&&yt<130&&xt>0&&xt<256){
          displaymenu(8);
          goto out;
        }
        if(yt>130&&yt<150&&xt>0&&xt<256){
          displaymenu(3);
          goto out;
        }
        if(yt>150&&yt<170&&xt>0&&xt<256){
          displaymenu(4);
          goto out;
        }
        if(yt>170&&yt<190&&xt>0&&xt<256){
          if(gs->d3d->WindowStyle == SW_SHOWMAXIMIZED)
			  gs->d3d->shownormal();
		  else
			  gs->d3d->showmaximized();
          goto out;
        }
        if(yt>190&&yt<210&&xt>0&&xt<256){
          PostQuitMessage(0);
          goto out;
        }
      }
	  // view.menutype == 6
      if(view.menutype==6){
        if(yt>50&&yt<70&&xt>0&&xt<256){
          displaymenu(0);
          goto out;
        }
        if(yt>70&&yt<90&&xt>0&&xt<256){
          displaymenu(7);
          goto out;
        }
        if(yt>90&&yt<110&&xt>0&&xt<256){
          displaymenu(3);
          goto out;
        }
        if(yt>110&&yt<130&&xt>0&&xt<256){
          displaymenu(4);
          goto out;
        }
        if(yt>130&&yt<150&&xt>0&&xt<256){
          if(gs->d3d->WindowStyle == SW_SHOWMAXIMIZED)
			  gs->d3d->shownormal();
		  else
			  gs->d3d->showmaximized();
          goto out;
        }
        if(yt>150&&yt<170&&xt>0&&xt<256){
          PostQuitMessage(0);
          goto out;
        }
      }
      if(view.menutype==3){
        for(i=0;i<DISPLAYEDMISSIONS;i++){
          if(yt>50+20*i&&yt<70+20*i&&xt>0&&xt<230){
            if(strlen(view.mfnames[i])>0){
              strcpy(mission.fname, "missions\\");
              strcat(mission.fname, view.mfnames[i]);
              killgame();
              gameinit();
              goto out;
            }
          }
        }
        if(yt>=60&&yt<80&&xt>240&&xt<250){
          if(view.menuscroll>0){
            view.menuscroll--;
            loadmenu(3);
            goto out;
          }
        }
        if(yt>80&&yt<100&&xt>240&&xt<250){
          if(view.menuscroll<view.menumaxscroll){
            view.menuscroll++;
            loadmenu(3);
            goto out;
          }
        }
      }
      if(view.menutype==7){
        for(i=0;i<DISPLAYEDMISSIONS;i++){
          if(yt>50+20*i&&yt<70+20*i&&xt>0&&xt<230){
            if(strlen(view.mfnames[i])>0){
              strcpy(mission.fname, "save\\");
              strcat(mission.fname, view.mfnames[i]);
              killgame();
              gameinit();
              goto out;
            }
          }
        }
        if(yt>=60&&yt<80&&xt>240&&xt<250){
          if(view.menuscroll>0){
            view.menuscroll--;
            loadmenu(7);
            goto out;
          }
        }
        if(yt>80&&yt<100&&xt>240&&xt<250){
          if(view.menuscroll<view.menumaxscroll){
            view.menuscroll++;
            loadmenu(7);
            goto out;
          }
        }
      }
      if(view.menutype==8){
        for(i=0;i<DISPLAYEDMISSIONS;i++){
          if(yt>50+20*i&&yt<70+20*i&&xt>0&&xt<230){
            if(strlen(view.mfnames[i])>0){
			  char *str = (char *)malloc(80);
              strcpy(str, "save\\");
              strcat(str, view.mfnames[i]);
			  savegame(str);
			  view.menu=false;
			  delete  str;
              goto out;
            }
          }
        }
        if(yt>=60&&yt<80&&xt>240&&xt<250){
          if(view.menuscroll>0){
            view.menuscroll--;
            loadmenu(8);
            goto out;
          }
        }
        if(yt>80&&yt<100&&xt>240&&xt<250){
          if(view.menuscroll<view.menumaxscroll){
            view.menuscroll++;
            loadmenu(8);
            goto out;
          }
        }
      }
    }
    out:
    mouse.down=false;
    mouse.rdown=false;
    mouse.up=false;
  }
}

void input(void){
	if(GetAsyncKeyState(27)!=0)
	{
		 if(view.menutype!=2){
			 if(view.firstperson){
			   mission.success=true;
			   if(strlen(mission.next)!=0){
				 strcpy(mission.fname, "missions\\");
				 strcat(mission.fname, mission.next);
			   }
			   newmenu(2);
			   view.timemenu=true;
			   view.menukilltime=speedgs.g;
			   mission.done=true;
			 } else {
				if(!view.lastesc)
				{
				   if(view.menu)
					   view.menu=false;
				   else
					   newmenu(1);
				}
			 }
		 }
		 if(view.menu&&view.menutype==2){view.menukilltime=speedgs.g-0.1f;}
		 view.lastesc = true;
	}
	else
		view.lastesc = false;
	// q key: quit immediately
	if(GetAsyncKeyState(0x51)!=0) PostQuitMessage(0);
	if(GetAsyncKeyState(0x71)!=0) PostQuitMessage(0);
  if(!view.firstperson){
    mouseinput();
/*  omil[0].sp=0;*/
	// zoom
    if(GetAsyncKeyState(0x6B)!=0){view.zoom-=speedgs.c*0.3f;view.changed = true;}
    if(GetAsyncKeyState(0x6D)!=0){view.zoom+=speedgs.c*0.3f;view.changed = true;}
    if(view.zoom<MINZOOM)view.zoom=0.5f;
    if(view.zoom>MAXZOOM)view.zoom=1.5f;
	// escape key
	if(GetAsyncKeyState(0x63)!=0&&view.menu&&view.menutype==4){view.menu=false;}
	if(GetAsyncKeyState(0x63)!=0&&(!view.menu||view.menutype!=4)){newmenu(4);}
	// o (0x4f, 0x6f): display orders
	if(GetAsyncKeyState(0x4f)!=0||GetAsyncKeyState(0x4f)!=0)
	{
		if(!view.lasto)
		{
			if(view.menu&&view.menutype==0){view.menu=false;}
			else if((!view.menu||view.menutype!=0)){newmenu(0);}
		}
		view.lasto = true;
	}
	else
		view.lasto = false;
	// scroll
    if(GetAsyncKeyState(0x25)!=0){view.px-=15*speedgs.c*view.zoom;mouse.downx+=speedgs.c*1.5f;view.changed = true;}
    if(GetAsyncKeyState(0x26)!=0){view.py+=15*speedgs.c*view.zoom;mouse.downy-=speedgs.c*1;view.changed = true;}
    if(GetAsyncKeyState(0x27)!=0){view.px+=15*speedgs.c*view.zoom;mouse.downx-=speedgs.c*1.5f;view.changed = true;}
    if(GetAsyncKeyState(0x28)!=0){view.py-=15*speedgs.c*view.zoom;mouse.downy+=speedgs.c*1;view.changed = true;}
    if(view.px<-LEFTEND+15)view.px=-LEFTEND+15;
    if(view.px>FIELDX*TERRAFAC-RIGHTEND)view.px=FIELDX*TERRAFAC-RIGHTEND;
    if(view.py<-BOTTOMEND+5)view.py=-BOTTOMEND+5;
    if(view.py>FIELDY*TERRAFAC-TOPEND)view.py=FIELDY*TERRAFAC-TOPEND;
  }
}
