#ifndef SOUND_H
#define SOUND_H

#include "constants.h"

#include <dsound.h>

// DirectSound
extern LPDIRECTSOUND8 dxsound;// main directsound handle
extern LPDIRECTSOUNDBUFFER dxsoundbuffer[SOUNDS*PARSOUNDS];// sound buffers
extern LPDIRECTSOUNDBUFFER dxonesoundbuffer[ONESOUNDS];// one-time sound buffers
extern char* dxssbuf[SOUNDS];// backup buffers
extern int dxssbuflen[SOUNDS];// buffer lengths
// time indices to prevent chaos when playing many sounds
extern float lastplayed[SOUNDS];
extern bool dxsoundok;// sound init was successful
void playone(int num);
void play(int num);

#endif