#ifndef T3MATH_H
#define T3MATH_H

#include <math.h>

#define PI 3.14159265359f

#define begr(x,y) ((x)>=0?(x)%(y):((x)+1)%(y)+(y)-1)

extern float sintable[65536];
extern float costable[65536];

#define tsin(x) (sintable[begr((int)((x)*10430.37835), 65536)])
#define tcos(x) (costable[begr((int)((x)*10430.37835), 65536)])

#define minf(x,y) ((x)<(y)?x:y)

// float abs function
#define absf(x) ((x)>=0?(x):-(x))

#define maxf(x,y) ((x)>(y)?x:y)

#define toint(x) ((x)>=0?(int)(x):(int)((x)-1))

// functions
void inittables(void);

float begrf(float x, float ber);

#endif